/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Name:				slx3_combine.fx																														//
// Programmierer:	Sebastian Leopold - Kontakt: Sebsatian Leopold @ aol.com																	//
// Copyright:		Copyright  2005 by Sebastian Leopold																							//
//-------------------------------------------------------------------------------------------------------------------------//
// Beschreibung:	Macht ein Schwarzweibild.																											//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*

	Weitere Informationen:
	
	Dieser Effekt ist ein Post - Processing effekt und besteht aus diesem Grund nur aus einem Pixelshader. Bei jedem der
	Post - Processing Effekte befindet sich die Original Scene in der zweiten Post - Texture. Dies ist auch der Fall wenn
	es sich um den ersten Effekt handelt, dann ist jedoch der erste und der zweie Slot gleich.
	
	Kombiniert das Bild
	
*/

// Texturen
texture postTex1;				// Post - Processing Texture ( enthlt das aktuelle Scenen Bild )
texture postTex2;				// Post - Processing Texture 2 ( enhlt immer das original Scenen Bild in Original Auflsung)
texture effTex1;				// Effekt Textur ( zustzliche Texture fr Spezial Effekte)	
texture effTex2;				// Effekt Textur ( zustzliche Texture fr Spezial Effekte)

// Variablen
float4 vecValues1;			// Enthlt die ersten 4 benutzerdefinierbaren Effektwerte
float4 vecValues2;			// Enthlt die zweiten 4 benutzerdefinierbaren Effektwerte

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Sampler fr Texturen in diesem Effekt
sampler currentScene = sampler_state
{
	texture 		= (postTex1);
	MinFilter	= linear;
	MagFilter	= linear;
	MipFilter	= linear;
	AddressU		= Clamp;
	AddressV		= Clamp;
};

sampler originalScene = sampler_state
{
	texture		= (postTex2);
	MinFilter	= linear;
	MagFilter	= linear;
	MipFilter	= linear;
	AddressU		= Clamp;
	AddressV		= Clamp;
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Fragmentprogramm fr Pixelberechnung
float4 Monochrom_PS(float2 texcoord0 : TEXCOORD0) : COLOR
{
	float4 pixel = tex2D(originalScene,texcoord0);
	return tex2D(currentScene,texcoord0) + pixel;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Technik 0 fr Monochrom Effekt
technique tech_00
{
	pass pass_00
	{
		// Effekt compillieren
		Pixelshader = compile ps_2_0 Monochrom_PS();
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Fallback Funktion --> No Effect
technique tech_01
{
	pass pass_00
	{
		Texture[0] = <postTex1>;
	}
}