/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Name:				slx3_pixellight.fx																													//
// Programmierer:	Sebastian Leopold - Kontakt: Sebsatian Leopold @ aol.com																	//
// Copyright:		Copyright  2005 by Sebastian Leopold																							//
//-------------------------------------------------------------------------------------------------------------------------//
// Beschreibung:	Shader fr Per-Pixel Omnie Light																									//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*

	Weitere Informationen:
	
	Dieser Effekt ist ein Shader fr ein Per-Pixel Licht das der Beleuchtung von Modellen dient. Auf diese Weie knnen Modelle
	die mit Sylex 3.0 gezeichnet werden bis zu acht Lichter gleichzeitig verwenden.
	
*/

// Matrizen
float4x4 matWorldViewProj;
float4x4 matLight;

// Ausgabestruktur fr Vertexshader
struct VS_OUTPUT {
	float4 Pos : POSITION;
	float2 Tex0 : TEXCOORD0;
	float2 Tex1 : TEXCOORD1;
};

// Vertexshader
VS_OUTPUT VS_PixelLight(float4 Pos : POSITION,float2 Tex : TEXCOORD0)
{
	VS_OUTPUT Out = (VS_OUTPUT)0;
		
	Out.Pos = mul(Pos,matWorldViewProj);
	Out.Tex0 = Tex;
	Out.Tex1 = mul(Pos,matLight);
	return Out;
}

texture entSkin1;

sampler texs1 = sampler_state
{
	texture = (entSkin1);
	MinFilter = linear;
	MagFilter = linear;
	MipFilter = linear;
};

float4 PS_PixelLight(float2 Tex0 : TEXCOORD0, float2 Tex1 : TEXCOORD1) : COLOR
{
	float4 temp = saturate(dot((Tex1 - 0.5f) * 2.0f,(Tex1 - 0.5f) * 2.0f));
	temp = (1 - temp) * float4(1.0f,0.25f,0.0f,1.0f);
	temp = temp * tex2D(texs1,Tex0);
	return temp;
}

// Technik
technique tech_00
{
	pass pass_00
	{
		SrcBlend = One;
		DestBlend = One;
		BlendOp = Add;
		AlphaBlendEnable = TRUE;
		
		
		VertexShader = compile vs_2_0 VS_PixelLight();
		PixelShader = compile ps_2_0 PS_PixelLight();
	}
}